SystemOrganization addCategory: #SystemAnnouncements!

TestCase subclass: #SAAnnouncementCreationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'Jre 10/23/2010 16:17'!
testCategoryAddedAnnouncement
	self assert: ((AddedEvent classCategory: 'XXX') asSystemAnnouncement isKindOf: SystemCategoryAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:10'!
testCategoryRemovedAnnouncement
	self assert: ((RemovedEvent classCategory: 'XXX') asSystemAnnouncement isKindOf: SystemCategoryRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:22'!
testCategoryRenamedAnnouncement
	self assert: ((RenamedEvent
					classCategoryRenamedFrom: 'anOldClassCategoryName' 
					to: 'aNewClassCategoryName')  asSystemAnnouncement isKindOf: SystemCategoryRenamedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'Jre 10/23/2010 16:58'!
testClassAddedAnnouncement
	self assert: ((AddedEvent class: Object category: 'XXX')  asSystemAnnouncement isKindOf: SystemClassAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 18:52'!
testClassCommentedAnnouncement
	self assert: ((CommentedEvent class: Object)  asSystemAnnouncement isKindOf: SystemClassCommentedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:33'!
testClassCommentedAnnouncement2
	self assert: ((CommentedEvent class: self class oldComment: 'oldComment' newComment: 'newComment' oldStamp: DateAndTime now newStamp: DateAndTime now)  asSystemAnnouncement isKindOf: SystemClassCommentedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:17'!
testClassRecategorizedAnnouncement
	self assert: ((RecategorizedEvent 
				class: self class
				category: 'newCategory'
				oldCategory: 'oldCategory')  asSystemAnnouncement isKindOf: SystemClassRecategorizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:11'!
testClassRemovedAnnouncement
	self assert: ((RemovedEvent class: Object category: 'XXX')  asSystemAnnouncement isKindOf: SystemClassRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:20'!
testClassRenamedAnnouncement
	self assert: ((RenamedEvent 
				class: self class
				category: 'aCategoryName'
				oldName: 'oldClassName'
				newName: 'NewClassName')  asSystemAnnouncement isKindOf: SystemClassRenamedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:28'!
testClassReorganizedAnnouncement
	self assert: ((ReorganizedEvent 
				class: self class)  asSystemAnnouncement isKindOf: SystemClassReorganizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:09'!
testMethodAddedAnnouncement
	self assert: ((AddedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:08'!
testMethodAddedAnnouncement2
	self assert: ((AddedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				protocol: 'protocol'
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 18:40'!
testMethodModifiedAnnouncement
	self assert: (((ModifiedMethodEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement' 
					inClass: self class
					requestor: nil)
					oldProtocol: 'oldProtocol';
					newProtocol: 'newProtocol') asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 18:50'!
testMethodModifiedAnnouncement2
	self assert: ((ModifiedEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement2
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement2'
					inClass: self class
					requestor: nil) asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 18:51'!
testMethodModifiedAnnouncement3
	self assert: ((ModifiedEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement2
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement2'
					inClass: self class) asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:17'!
testMethodRecategorizedAnnouncement
	self assert: ((RecategorizedEvent 
				method: (self class >> #testMethodRecategorizedAnnouncement)
				protocol: 'newCategory'
				class: self class
				oldProtocol: 'oldCategory')  asSystemAnnouncement isKindOf: SystemMethodRecategorizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:12'!
testMethodRemovedAnnouncement
	self assert: ((RemovedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:12'!
testMethodRemovedAnnouncement2
	self assert: ((RemovedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				protocol: 'protocol'
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'tg 10/23/2010 17:21'!
testMethodRenamedAnnouncement
	self assert: ((RenamedEvent 
				class: self class
				category: 'aCategoryName'
				oldName: 'oldClassName'
				newName: 'NewClassName')  asSystemAnnouncement isKindOf: SystemClassRenamedAnnouncement)! !

TestCase subclass: #SACategoryAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'tg 10/23/2010 18:56'!
testAddedCategory
	"self debug: #testAddedCategory"
	| addedCount addedCat | 
	[
		addedCount := 0.
		SystemAnnouncer initialize.
		SystemAnnouncer announcer when: SystemCategoryAddedAnnouncement do: [ :ann | 
			addedCount := addedCount + 1. 
			addedCat := ann event item].
		Smalltalk organization addCategory: 'XXXXX'.
		self assert: addedCat = 'XXXXX'.
		self assert: addedCount = 1.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX' ]! !

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'tg 10/23/2010 18:56'!
testRemovedCategory
	| count addedCat | 
	[
		count := 0.
		addedCat := ''.
		SystemAnnouncer initialize.
		Smalltalk organization addCategory: 'XXXXX'.
		SystemAnnouncer announcer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self ]! !

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'tg 10/23/2010 18:56'!
testRenamedCategory
	"self debug: #testRenamedCategory"
	| newCategory oldCategory | 
	[
		SystemAnnouncer initialize.
		SystemAnnouncer announcer when: SystemCategoryRenamedAnnouncement do: [ :ann | 
			newCategory := ann newName.
			oldCategory := ann oldName.].
		Smalltalk organization addCategory: 'XXXXX'.
		Smalltalk organization renameCategory: 'XXXXX' toBe: 'YY'.
		self assert: newCategory = 'YY'.
		self assert: oldCategory = 'XXXXX'.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'YY' ]! !

TestCase subclass: #SAClassAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAClassAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 18:56'!
testAddedClass
	| count | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		SystemAnnouncer announcer when: SystemClassRemovedAnnouncement do: [ :ann | 
			count := count + 1. ].
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem.
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self ]! !

!SAClassAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 18:56'!
testRecategorizedClass
	"self debug: #testRecategorizedClass"
	
	| newCat oldCat itemClass |
	[
		Object subclass: #XXXX
			instanceVariableNames: '' 
			classVariableNames: '' 
			poolDictionaries: '' 
			category: 'OriginalCategory'.
		SystemAnnouncer initialize.
		SystemAnnouncer announcer when: SystemClassRecategorizedAnnouncement do: [ :ann | 
			newCat := ann newCategory.
			oldCat := ann oldCategory.
			itemClass := ann itemClass.
			 ].
		(Smalltalk at: #XXXX) category: 'Y'.
		self assert: newCat  = 'Y'.
		self assert: oldCat = 'OriginalCategory'.
		self assert: itemClass = (Smalltalk at: #XXXX).
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self ]! !

!SAClassAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 18:56'!
testRemovedCategory
	| count | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Smalltalk organization addCategory: 'XXXXX'.
		SystemAnnouncer announcer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self ]! !

TestCase subclass: #SAMethodAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAMethodAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 18:56'!
testAddedMethod
	"self debug: #testAddedMethod"
	| count protocol selector class | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		SystemAnnouncer announcer when: SystemMethodAddedAnnouncement do: [ :ann | 
			count := count + 1. 
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass].
		(Smalltalk at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk at: #XXXX).
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self.
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 18:56'!
testRemovedMethod
	"self debug: #testRemovedMethod"
	| count protocol selector class | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		(Smalltalk at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		SystemAnnouncer announcer when: SystemMethodRemovedAnnouncement do: [ :ann | 
			count := count + 1.
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		(Smalltalk at: #XXXX) removeSelector: #m.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk at: #XXXX).
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self.
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem ]! !

TestCase subclass: #SAProtocolAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAProtocolAnnouncementTest commentStamp: '<historical>' prior: 0!
For now Protocol addition is not well managed at the level of SystemChangeNotifier so we will not cover it.

We will cover it via method modification!

!SAProtocolAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'Jre 10/23/2010 16:06'!
expectedFailures 

	^ #()! !

!SAProtocolAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 10/23/2010 19:00'!
testAddedProtocol
	"self debug: #testAddedProtocol"
	| addedCount class | 
	[
		addedCount := 0.
		SystemAnnouncer initialize.
		SystemAnnouncer announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			addedCount := addedCount + 1.
			class := ann event item ].
		self class organization addCategory: 'protocol - addition'.
		self assert: addedCount = 1.
		self assert: class = self class.
	] ensure: [
		SystemAnnouncer announcer unsubscribe: self.
		SAProtocolAnnouncementTest organization removeCategory: 'protocol - addition' ]! !

Announcer subclass: #SystemAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncer class
	instanceVariableNames: 'announcer categoryAnnouncer classAnnouncer protocolAnnouncer methodAnnouncer expressionAnnouncer'!

!SystemAnnouncer commentStamp: '<historical>' prior: 0!
This class plays the role of the announcer for events raised by the Pharo system.

Currently, it acts as a wrapper over the SystemChangeNotifier, but in the future it should be used for announcing the events directly from the system.!

SystemAnnouncer class
	instanceVariableNames: 'announcer categoryAnnouncer classAnnouncer protocolAnnouncer methodAnnouncer expressionAnnouncer'!

!SystemAnnouncer class methodsFor: 'private' stamp: 'tg 10/23/2010 18:55'!
announceFromEvent: aChangeEvent
	"This method creates an announcement from a given Event (subclass of AbstractEvent) and announces it.
	
	For example, from an AddedEvent that concerns a class the method creates SystemAddedClassAnnouncement and then it will announce it both from the generic announcer and from the classAnnouncer "
	self announcer announce: aChangeEvent asSystemAnnouncement.! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:17'!
announcer
	"Answer a system annoncer."
	
	^ announcer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:13'!
categoryAnnouncer
	"Answer a category annoncer."
	
	^ categoryAnnouncer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:13'!
classAnnouncer
	"Answer a class annoncer."
	
	^ classAnnouncer! !

!SystemAnnouncer class methodsFor: 'utilities' stamp: 'Jre 10/23/2010 16:23'!
defaultPreferredAnnouncementClassForEvent: aChangeEvent
	| itemKindName eventKindName announcementClassName announcementClass |
	itemKindName := aChangeEvent itemKind.
	eventKindName := (aChangeEvent class name endsWith: 'Event') 
		ifTrue: [ aChangeEvent class name copyFrom: 1 to: aChangeEvent class name size - 'Event' size ] 
		ifFalse: [ aChangeEvent class name ].
	announcementClassName := 	(
										'System', 
										itemKindName capitalized, 
										eventKindName,
										'Announcement'
									) asSymbol.
	announcementClass := Smalltalk at: announcementClassName ifAbsent: [nil].
	^ announcementClass! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
expressionAnnouncer
	"Answer a expression annoncer."
	
	^ expressionAnnouncer! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'cyrille.delaunay 11/18/2010 10:37'!
initialize

	"self initialize"
	announcer := Announcer new.
	categoryAnnouncer := Announcer new.
	classAnnouncer := Announcer new.
	protocolAnnouncer := Announcer new.
	methodAnnouncer := Announcer new.
	expressionAnnouncer := Announcer new.
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #announceFromEvent:! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
methodAnnouncer
	"Answer a method annoncer."
	
	^ methodAnnouncer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
protocolAnnouncer
	"Answer a protocol annoncer."
	
	^ protocolAnnouncer! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'lr 2/22/2010 11:10'!
unload
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!ReorganizedEvent methodsFor: '*SystemAnnouncements' stamp: 'StephaneDucasse 7/15/2010 23:19'!
category

	^self itemCategory! !

!RPackage methodsFor: '*SystemAnnouncements' stamp: 'cyrilledelaunay 1/5/2011 15:42'!
removeClass: aClass

	"unregister the class and all its methods from this RPackage"
	|methodsRemoved tmpDefinedMethods tmpMethodDict tmpDefinedSelectors homeMadeMethods originalNumberOfMethods numberOfMethodsViewed|
	"methodsRemoved := OrderedCollection new.
	originalNumberOfMethods := (self definedMethodsForClass: aClass) size.
	tmpDefinedSelectors := (classDefinedSelectors at: #NewClass) copy.
	tmpMethodDict := OrderedCollection withAll: aClass methodDict values copy.
	homeMadeMethods := tmpDefinedSelectors collect: [:aSelector | tmpMethodDict detect: [:aMethod | aMethod selector = aSelector ] ].
	tmpDefinedMethods := OrderedCollection withAll: (self definedMethodsForClass: aClass).
	self haltIf: [tmpDefinedMethods size = 1].
	numberOfMethodsViewed := 0."
	(self definedMethodsForClass: aClass) do: [ :aCompiledMethod | 
		"numberOfMethodsViewed :=  numberOfMethodsViewed + 1."
		"methodsRemoved add:" (self removeDefinedMethod: aCompiledMethod forClass: aClass).
		].
	"self haltIf: [
		(self definedMethodsForClass: aClass) isEmpty not  ]."
	self removeClassDefinitionWithoutCheckingMethods: aClass.! !

!RPackage methodsFor: '*SystemAnnouncements' stamp: 'cyrilledelaunay 1/5/2011 13:05'!
removeClassDefinitionWithoutCheckingMethods: aClass
	"Same than 'removeClassDefinition', excepts that it does not make any check to set defined methods as extensions"
	
	| removed aClassName|
	aClassName := aClass theNonMetaClass name.
	removed := classes remove: aClassName ifAbsent: [nil].
	removed ifNotNil: [
			self unregisterClass: aClass.] 
	! !

!RPackage methodsFor: '*SystemAnnouncements' stamp: 'cyrilledelaunay 1/5/2011 14:15'!
removeDefinedMethod: aCompiledMethod forClass: aClass 
	"Remove the method to the receiver as a defined method."

	aClass isMeta
					ifTrue: [(metaclassDefinedSelectors 
								at: aClass theNonMetaClass name  
								ifAbsent: [^nil]) remove: aCompiledMethod selector]
					ifFalse: [(classDefinedSelectors 
								at: aClass name 
								ifAbsent: [^nil]) remove: aCompiledMethod selector].	
	^ aCompiledMethod.! !

!ModifiedMethodEvent methodsFor: '*systemannouncements' stamp: 'tg 10/23/2010 18:42'!
asSystemAnnouncement
	^ SystemMethodModifiedAnnouncement new event: self! !

!AbstractEvent methodsFor: '*systemannouncements' stamp: 'tg 10/23/2010 17:54'!
asSystemAnnouncement
	| itemKindName eventKindName announcementClassName announcementClass |
	itemKindName := self itemKind.
	eventKindName := (self class name endsWith: 'Event') 
		ifTrue: [ self class name copyFrom: 1 to: self class name size - 'Event' size ] 
		ifFalse: [ self class name ].
	announcementClassName := 	(
										'System', 
										itemKindName capitalized, 
										eventKindName,
										'Announcement'
									) asSymbol.
	announcementClass := Smalltalk at: announcementClassName ifAbsent: [nil].
	^ announcementClass isNil 
		ifTrue: [SystemUnknownAnnouncement new]
		ifFalse: [announcementClass new event: self]! !

Announcement subclass: #SystemAnnouncement
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemAnnouncement commentStamp: '<historical>' prior: 0!
The root announcement for the events coming from the Pharo system.

Currently, it wraps the event that comes from the SystemChangeNotifier.!

!SystemAnnouncement methodsFor: 'accessing' stamp: 'tg 6/5/2010 12:17'!
event
	^ event! !

!SystemAnnouncement methodsFor: 'accessing' stamp: 'tg 6/5/2010 12:17'!
event: anObject
	event := anObject! !

SystemAnnouncement subclass: #SystemCategoryAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemCategoryAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/28/2010 10:34'!
item
	^ event item! !

SystemAnnouncement subclass: #SystemCategoryRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemCategoryRenamedAnnouncement
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemCategoryRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/27/2010 21:59'!
newName

	^ event newName! !

!SystemCategoryRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/27/2010 21:59'!
oldName

	^ event oldName! !

SystemAnnouncement subclass: #SystemClassAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassCommentedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassRecategorizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassRecategorizedAnnouncement commentStamp: '<historical>' prior: 0!
SystemClassRecategorizedAnnouncement is sent when a class got its category changed - not its internal protocol organization. !

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/27/2010 22:38'!
itemClass 

	^ event itemClass ! !

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/28/2010 09:09'!
newCategory 

	^ event itemCategory ! !

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/27/2010 22:39'!
oldCategory 

	^ event oldCategory ! !

SystemAnnouncement subclass: #SystemClassRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassRenamedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassReorganizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassReorganizedAnnouncement commentStamp: '<historical>' prior: 0!
This corresponds to ReorganizedEvent, which seems to be raised when:
- we change the categories in the lower pane of OB
- we add a protocol
- we remove a protocol!

SystemAnnouncement subclass: #SystemMethodAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemClass

	^ event itemClass
	! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemProtocol

	^ event itemProtocol! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemSelector

	^ event itemSelector
	! !

SystemAnnouncement subclass: #SystemMethodModifiedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemMethodRecategorizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemMethodRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:29'!
itemClass

	^ event itemClass
	! !

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:29'!
itemProtocol

	^ event itemProtocol! !

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:30'!
itemSelector

	^ event itemSelector
	! !

SystemAnnouncement subclass: #SystemProtocolAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemProtocolAddedAnnouncement commentStamp: '<historical>' prior: 0!
This class is not used, but should be used when we hook into the addition and removal of protocols. Right now, we only get ClassReorganizedAnnouncement!

SystemAnnouncement subclass: #SystemProtocolRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemProtocolRemovedAnnouncement commentStamp: '<historical>' prior: 0!
This class is not used, but should be used when we hook into the addition and removal of protocols. Right now, we only get ClassReorganizedAnnouncement!

SystemAnnouncement subclass: #SystemUnknownAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!
SystemAnnouncer initialize!
